class KindergartenGarden(private val diagram: String) {
    private enum class Student(i: Int) {
        Alice(0),
        Bob(1),
        Charlie(2),
        David(3),
        Eve(4),
        Fred(5),
        Ginny(6),
        Harriet(7),
        Ileana(8),
        Joseph(9),
        Kincaid(10),
        Larry(12)
    }

    private enum class Plant(s: String) {
        Violet("V") {
            override fun toString(): String = "violets"
        },
        Grass("G") {
            override fun toString(): String = "grass"
        },
        Clover("C") {
            override fun toString(): String = "clover"
        },
        Radish("R") {
            override fun toString(): String = "radishes"
        }
    }

    private val studentToPlants: Map<Student, List<Plant>>
    init {
        val k = mutableMapOf<Student, MutableList<Plant>>()
        val rows = diagram.split("\n").map { row -> row.map { it.toString().toPlant() } }
        for (group in 0 until (rows[0].size / 2)){
            val plants = mutableListOf<Plant>()
            with(plants) {
                add(rows[0][2 * group])
                add(rows[0][(2 * group) + 1])
                add(rows[1][2 * group])
                add(rows[1][(2 * group) + 1])
            }
            k[group.toStudent()] = plants
        }
        studentToPlants = k
    }

    private fun String.toPlant(): Plant {
        return when (this) {
            "V" -> Plant.Violet
            "G" -> Plant.Grass
            "C" -> Plant.Clover
            "R" -> Plant.Radish
            else -> throw IllegalArgumentException("Bad Plant Type. Must be one of V, G, C, R")
        }
    }
    private fun String.toStudent(): KindergartenGarden.Student {
        return when(this) {
            "Alice" -> Student.Alice
            "Bob" -> Student.Bob
            "Charlie" -> Student.Charlie
            "David" -> Student.David
            "Eve" -> Student.Eve
            "Fred" -> Student.Fred
            "Ginny" -> Student.Ginny
            "Harriett" -> Student.Harriet
            "Ileana" -> Student.Ileana
            "Joseph" -> Student.Joseph
            "Kincaid" -> Student.Kincaid
            "Larry" -> Student.Larry
            else -> throw IllegalArgumentException("Bad student name $this")
        }
    }

    private fun Int.toStudent(): KindergartenGarden.Student {
        return when (this) {
            0 -> Student.Alice
            1 -> Student.Bob
            2 -> Student.Charlie
            3 -> Student.David
            4 -> Student.Eve
            5 -> Student.Fred
            6 -> Student.Ginny
            7 -> Student.Harriet
            8 -> Student.Ileana
            9 -> Student.Joseph
            10 -> Student.Kincaid
            11 -> Student.Larry
            else -> throw IllegalArgumentException("Bad student number $this")
        }
    fun getPlantsOfStudent(student: String): List<String> {
        TODO("Implement the function to complete the task")
    }
}

    fun getPlantsOfStudent(student: String): List<String> {
        return studentToPlants[student.toStudent()]?.map { it.toString() } ?: emptyList()
    }
}
